de.caff.generics.mda

## Interface TwoDimensionalFloatReadAccess

- All Superinterfaces:
    MultiDimensional, MultiDimensionalReadAccess<java.lang.Float>, TwoDimensionalReadAccess<java.lang.Float>
  All Known Subinterfaces:
    TwoDimensionalFloatAccess
  All Known Implementing Classes:
    SmallTwoDimensionalFloatArray, TwoDimensionalFloatArray, TwoDimensionalFloatReadAccess.Base

      public interface TwoDimensionalFloatReadAccess
      extends TwoDimensionalReadAccess<java.lang.Float>

  Read access for 2-dimensional rectangular float arrays.
  Since:
    November 11, 2019
  Author:
    Rammi

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface and Description
    --- | ---
    `static class` | `TwoDimensionalFloatReadAccess.Base` Base class implementing this interface which provides useful default methods for `Object.toString()`, `Object.equals(Object)`, and `Object.hashCode()`.

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static TwoDimensionalFloatReadAccess` | `EMPTY` Empty 2dimensional float read access.

    - ### Fields inherited from interface de.caff.generics.mda.MultiDimensionalReadAccess

      `EMPTY0, EMPTY1, EMPTY2, EMPTY3, EMPTY4, EMPTY5, EMPTY6, EMPTY7`

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `default TwoDimensionalFloatReadAccess.Base` | `asBase()` Get a view of this 2-dimensional access which provides useful defaults for standard object methods.
    `default java.lang.Float` | `getElementAt(int ix, int iy)` Get the element at the given indexes.
    `float` | `getValueAt(int ix, int iy)` Get the value at the given indexes.
    `static TwoDimensionalFloatReadAccess` | `singleton(float singleElement)` Get a 2dimensional float read access for a single element.
    `default OneDimensionalFloatReadAccess` | `subAtX(int ix)` Get a 1-dimensional view of the row at the given X index.
    `default OneDimensionalFloatReadAccess` | `subAtY(int iy)` Get a 1-dimensional view of the column at the given X index.
    `default TwoDimensionalFloatReadAccess` | `transposed()` Get a transposed view of this 2-dimensional read access.

    - ### Methods inherited from interface de.caff.generics.mda.TwoDimensionalReadAccess

      `empty, equal, getElement, getNumDimensions, getNumElements, getSize, getSizes, hash, sizeX, sizeY, toString, view, visitAll, visitAll, xIterable, xIterator, yIterable, yIterator`

    - ### Methods inherited from interface de.caff.generics.mda.MultiDimensionalReadAccess

      `empty, linearized`

- - ### Field Detail

    - #### EMPTY

          static final TwoDimensionalFloatReadAccess EMPTY

      Empty 2dimensional float read access.

  - ### Method Detail

    - #### getValueAt

          float getValueAt(int ix,
                           int iy)

      Get the value at the given indexes.
      Parameters:
        `ix` - X index
        `iy` - Y index
      Returns:
        value at the given index

    - #### getElementAt

          @NotNull
          default java.lang.Float getElementAt(int ix,
                                                        int iy)

      Description copied from interface: `TwoDimensionalReadAccess`
      Get the element at the given indexes.
      Specified by:
        `getElementAt` in interface `TwoDimensionalReadAccess<java.lang.Float>`
      Parameters:
        `ix` - index in X direction from `0` (included) to `TwoDimensionalReadAccess.sizeX()` (excluded)
        `iy` - index in Y direction from `0` (included) to `TwoDimensionalReadAccess.sizeY()` (excluded)
      Returns:
        element at the given indexes

    - #### subAtX

          @NotNull
          default OneDimensionalFloatReadAccess subAtX(int ix)

      Description copied from interface: `TwoDimensionalReadAccess`
      Get a 1-dimensional view of the row at the given X index. This is a view, so setting elements will change values in this array.
      Specified by:
        `subAtX` in interface `TwoDimensionalReadAccess<java.lang.Float>`
      Parameters:
        `ix` - X index
      Returns:
        1-dimensional array at `ix`

    - #### subAtY

          @NotNull
          default OneDimensionalFloatReadAccess subAtY(int iy)

      Description copied from interface: `TwoDimensionalReadAccess`
      Get a 1-dimensional view of the column at the given X index. This is a view, so setting elements will change values in this array.
      Specified by:
        `subAtY` in interface `TwoDimensionalReadAccess<java.lang.Float>`
      Parameters:
        `iy` - Y index
      Returns:
        1-dimensional array at `iy`

    - #### transposed

          @NotNull
          default TwoDimensionalFloatReadAccess transposed()

      Description copied from interface: `TwoDimensionalReadAccess`
      Get a transposed view of this 2-dimensional read access.
      Specified by:
        `transposed` in interface `TwoDimensionalReadAccess<java.lang.Float>`
      Returns:
        transposed view where X and Y are interchanged

    - #### asBase

          @NotNull
          default TwoDimensionalFloatReadAccess.Base asBase()

      Get a view of this 2-dimensional access which provides useful defaults for standard object methods.
      Specified by:
        `asBase` in interface `TwoDimensionalReadAccess<java.lang.Float>`
      Returns:
        base view of this object

    - #### singleton

          @NotNull
          static TwoDimensionalFloatReadAccess singleton(float singleElement)

      Get a 2dimensional float read access for a single element.
      Specified by:
        `singleton` in interface `TwoDimensionalReadAccess<java.lang.Float>`
      Parameters:
        `singleElement` - single element
      Returns:
        2dimensional float read access with size 1 in both directions, containing just the given single element